#!/usr/bin/perl -w

# This nagios plugin come with ABSOLUTELY NO WARRANTY. You may redistribute copies
# of the plugins under the terms of the GNU General Public License.
# For more information about these matters, see the file named COPYING.
#
# revision 0.2 (i.e. Extreme Beta use at your own risk)
#

use strict;

use lib "/usr/local/nagios/libexec";
use utils qw($TIMEOUT %ERRORS &print_revision &support);
use vars qw($PROGNAME);
my ($hostname, $command, $state, @output, $result, $file, $i, $len);

$state = 'OK';

$ENV{'BASH_ENV'}='';
$ENV{'ENV'}='';
$ENV{'PATH'}='';
$PROGNAME = "remote_info.cgi";
sub print_help ();
sub print_usage ();
sub get_info();



# If called from a web page as a cgi uncomment this line and comment out the one below
$ARGV[0] =~ /(.*)\\&(.*)/;

# If called by command line uncomment this line and comment out the one above
#$ARGV[0] =~ /(.*)&(.*)/;

$hostname = $1;
$command = $2; 

# testing
#print "ARGV[0]: $ARGV[0]\n";
#print "Hostname: $hostname, Command: $command\n";


$SIG{'ALRM'} = sub {
        print ("ERROR: No response from RPC server (alarm)\n");
        exit $ERRORS{"UNKNOWN"};
};
alarm($TIMEOUT);

&get_info();

exit $ERRORS{$state};


########  Subroutines ==========================

sub get_info() {


	@output = ("Content-Type: text/html\n",
	"\n",
	"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n",
	"<HTML>\n<HEAD>\n",
	"<meta HTTP-EQUIV='Pragma' CONTENT='no-cache'>\n",
	"<TITLE>Remote Plugin Help</TITLE>\n",
	"</HEAD>\n<BODY>\n",
	"<CENTER><H3>Remote Plugin Help for $hostname</H3></CENTER><P>");

	$result = `/usr/local/nagios/libexec/check_nrpe  $hostname -p 5666 -c $command`;
	$result =~ s/~/\n<BR>/g;
	
	@output = (@output, $result);
	while($result !~ /<BR>EOF/){
		$result =~ /<BR>(text[1-9])/;
		$file = $1;
# testing
#print "File: get_$file\n";

		$result = `/usr/local/nagios/libexec/check_nrpe  $hostname -p 5666 -c get_$file`;
        	$result =~ s/~/\n<BR>/g;
		
		@output = (@output, $result);
	}
	$len = @output;
	$i = 0;	
	while($i < $len){
		$output[$i] =~ s/text[1-9]//g;
		$i++;
	}
	@output = (@output, "</BODY>\n</HTML>\n");


print @output;

return

}

sub print_help() {
        print_revision($PROGNAME,'$Revision: 0.2 $ ');
        print "Copyright (c) 2002 Daniel Rusch & Daniel Kressin\n";
        print "\n";
        print "This script combined with get_info can return virtually unlimited amounts of data\n";
        print "This script executes a command through nrpe on the remote host, and loops until EOF";
        print "\n";
        print_usage();
        print "\n";
        print "\n";
        support();
}

sub print_usage () {
        print "Usage if called via a web page: \n";
        print " $PROGNAME?<hostname>&<command>\n";
        print "Usage if called via command line: \n";
        print " $PROGNAME <hostname> <command>\n";
        print " $PROGNAME [-h | --help]\n";
        print " $PROGNAME [-V | --version]\n";
}

